SystemOrganization addCategory: #MultiplayerDungeonGame!

ImageMorph subclass: #GameBox
	instanceVariableNames: 'x y occupant usable northWall eastWall southWall westWall lineWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBox commentStamp: '<historical>' prior: 0!
A GameBox is a box on the game grid.  has walls, denizen occupant, and usable item.

Instance Variables
	eastWall:		bool
	lineWidth:		bool
	northWall:		bool
	occupant:		denizen
	southWall:		bool
	usable:		usable
	westWall:		bool
	x:		int
	y:		int
!

!GameBox class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/17/2014 02:27'!
northWall: aBool1 eastWall: aBool2 southWall: aBool3 westWall: aBool4 tileImage: aString.
	^self new northWall: aBool1 eastWall: aBool2 southWall: aBool3 westWall: aBool4 tileImage: aString.! !

!GameBox methodsFor: 'hashing' stamp: 'HenrySolberg 7/15/2014 03:51'!
binaryWallRepresentation
	|representation|
	representation := 0.
	northWall ifTrue: [ representation := representation + 1000 ].
	eastWall ifTrue: [ representation := representation + 100 ].
	southWall ifTrue: [ representation := representation + 10 ].
	westWall ifTrue: [ representation := representation + 1 ].
	^Integer readFrom: representation asString base: 2.! !

!GameBox methodsFor: 'drawing' stamp: 'HenrySolberg 7/17/2014 02:27'!
drawBorders
	|topMorph rightMorph bottomMorph leftMorph|
	topMorph := Morph new.
	rightMorph := Morph new.
	bottomMorph := Morph new.
	leftMorph := Morph new.
	topMorph color: Color black.
	rightMorph color: Color black.
	bottomMorph color: Color black.
	leftMorph color: Color black.
	topMorph position: self left@self top.
	topMorph height: lineWidth.
	topMorph width: self width.
	rightMorph position: (self right - lineWidth) @ self top.
	rightMorph width: lineWidth.
	rightMorph height: self height.
	bottomMorph position: self left@(self bottom - lineWidth).
	bottomMorph height: lineWidth.
	bottomMorph width: self width.
	leftMorph position: self left@ self top.
	leftMorph width: lineWidth.
	leftMorph height: self height.
	northWall ifTrue: [self addMorph: topMorph].
	eastWall ifTrue: [self addMorph: rightMorph].
	southWall ifTrue: [self addMorph: bottomMorph].
	westWall ifTrue: [self addMorph: leftMorph].! !

!GameBox methodsFor: 'drawing' stamp: 'HenrySolberg 7/16/2014 00:24'!
drawBorders: lineWidth
	|topMorph rightMorph bottomMorph leftMorph|
	topMorph := Morph new.
	rightMorph := Morph new.
	bottomMorph := Morph new.
	leftMorph := Morph new.
	topMorph color: Color black.
	rightMorph color: Color black.
	bottomMorph color: Color black.
	leftMorph color: Color black.
	topMorph position: self left@self top.
	topMorph height: lineWidth.
	topMorph width: self width.
	rightMorph position: (self right - lineWidth) @ self top.
	rightMorph width: lineWidth.
	rightMorph height: self height.
	bottomMorph position: self left@(self bottom - lineWidth).
	bottomMorph height: lineWidth.
	bottomMorph width: self width.
	leftMorph position: self left@ self top.
	leftMorph width: lineWidth.
	leftMorph height: self height.
	northWall ifTrue: [self addMorph: topMorph].
	eastWall ifTrue: [self addMorph: rightMorph].
	southWall ifTrue: [self addMorph: bottomMorph].
	westWall ifTrue: [self addMorph: leftMorph].! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:18'!
eastWall
	^eastWall.! !

!GameBox methodsFor: 'modifying' stamp: 'WestonPanther 7/16/2014 13:29'!
eastWall: aBool
	eastWall := aBool.! !

!GameBox methodsFor: 'hashing' stamp: 'HenrySolberg 7/15/2014 03:52'!
hash
	^occupant hash * 100 + self binaryWallRepresentation.! !

!GameBox methodsFor: 'initializing' stamp: 'HenrySolberg 7/17/2014 02:27'!
initialize
	super initialize.
	x := 0.
	y := 0.
	northWall := true.
	eastWall := true.
	southWall := true.
	westWall := true.
	occupant := nil.
	lineWidth := 2.! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:18'!
northWall
	^northWall.! !

!GameBox methodsFor: 'modifying' stamp: 'WestonPanther 7/16/2014 13:29'!
northWall: aBool
	northWall := aBool.
! !

!GameBox methodsFor: 'initializing' stamp: 'HenrySolberg 7/17/2014 02:25'!
northWall: aBool1 eastWall: aBool2 southWall: aBool3 westWall: aBool4 tileImage: aString
	self form: (ImageReadWriter formFromFileNamed: aString).
	self northWall: aBool1.
	self eastWall: aBool2.
	self southWall: aBool3.
	self westWall: aBool4.! !

!GameBox methodsFor: 'accessing' stamp: 'HEnrySolberg 7/10/2014 05:23'!
occupant
	^occupant! !

!GameBox methodsFor: 'modifying' stamp: 'HEnrySolberg 7/10/2014 05:23'!
setOccupant: aGameObject.
	occupant := aGameObject.! !

!GameBox methodsFor: 'modifying' stamp: 'WestonPanther 7/16/2014 16:16'!
setUsable: aUsable
	usable := aUsable.! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:18'!
southWall
	^southWall.! !

!GameBox methodsFor: 'modifying' stamp: 'WestonPanther 7/16/2014 13:30'!
southWall: aBool
	southWall := aBool.
! !

!GameBox methodsFor: 'accessing' stamp: 'WestonPanther 7/16/2014 16:16'!
usable
	^usable! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:18'!
westWall
	^westWall.! !

!GameBox methodsFor: 'modifying' stamp: 'WestonPanther 7/16/2014 13:30'!
westWall: aBool
	westWall := aBool.
! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 04:27'!
x
	^x! !

!GameBox methodsFor: 'modifying' stamp: 'HEnrySolberg 7/10/2014 04:33'!
x: anX
	x := anX.! !

!GameBox methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 04:27'!
y
	^y! !

!GameBox methodsFor: 'modifying' stamp: 'HEnrySolberg 7/10/2014 04:24'!
y: aY
	y := aY.! !

ImageMorph subclass: #GameObject
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameObject commentStamp: '<historical>' prior: 0!
A GameObject represents an entity that can occupy a space in the dungeon.

Instance Variables
	x:		<Object>
	y:		<Object>

x
	- xxxxx

y
	- xxxxx
!

GameObject subclass: #Denizen
	instanceVariableNames: 'health weapon armor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Denizen commentStamp: '<historical>' prior: 0!
A Denizen is a living, breathing, moving, attacking game object.
!

!Denizen class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:09'!
defaultPathName
	^'player.png'! !

!Denizen class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:22'!
onLevel: anInt
	^self defaultPath! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:11'!
armor
	^armor! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:37'!
armor: anArmor
	armor := anArmor.! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 17:56'!
attack: aDenizen onBoard: aBoard
	| damage |
	damage := self weapon damage.
	((aDenizen armor evasion) <= (aBoard rand nextInt: self weapon accuracy)) 
		ifTrue: [ 
			aDenizen health: (aDenizen health - ((damage - aDenizen armor reduction) max: 0))
			].
	(aDenizen health <= 0) ifTrue: 
		[ 
			aDenizen delete. 
			aBoard remove: aDenizen.
			(aDenizen = aBoard player)
				ifTrue: [ aBoard gameOver. ]
				ifFalse: [ aBoard player health: (aBoard player health + 1) ].
		]! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 03:22'!
health
	^health! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 17:56'!
health: anAmount
	health := anAmount.! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:11'!
initialize
	super initialize.
	health := 10.
	weapon := Weapon new.
	armor := Armor new.! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:53'!
isEnemy
	^false! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/17/2014 05:15'!
isUsable
	^false! !

!Denizen methodsFor: 'moving' stamp: 'HenrySolberg 7/24/2014 05:32'!
moveOnBoard: aBoard toX: toX toY: toY
	| occupant |
	occupant := (aBoard at: toX at: toY).
	(occupant) ifNil: [
		aBoard fromX: x fromY: y toX: toX toY: toY.
		x := toX.
		y := toY.
	] ifNotNil: [ 
		self attack: occupant onBoard: aBoard.
		occupant attack: self onBoard: aBoard.
	].
	aBoard setupHUDInWindow: (aBoard window).! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/16/2014 16:28'!
use: anObject
	(anObject isUsable) ifTrue: [ 
		anObject applyTo: self.	
	]! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/16/2014 17:33'!
useOnBoard:aBoard
	|anObject|
	anObject:= (aBoard boxAt: x at: y) usable.
	(anObject = nil) ifFalse: [ 
		anObject applyTo: self onBoard: aBoard.
	]! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:11'!
weapon
	^weapon! !

!Denizen methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/23/2014 13:34'!
weapon: aWeapon
	weapon := aWeapon! !

Denizen subclass: #Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Enemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 00:39'!
defaultPathName
	^'enemy.png'! !

!Enemy class methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/24/2014 14:55'!
enemyList
	^enemyList! !

!Enemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 03:57'!
initialize
	super initialize.! !

!Enemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 04:49'!
onLevel: anInt
	|newEnemy|

	(anInt < 6) ifTrue: [newEnemy := (RandomEnemy defaultPath)].
	((11 > anInt) & (anInt >= 6)) ifTrue: [newEnemy := (ManhattanEnemy defaultPath)].
	(anInt >= 11) ifTrue: [newEnemy := (PathfindingEnemy defaultPath)].
	
	newEnemy weapon: (Weapon enemyWeaponLevel: anInt).
	newEnemy armor: (Armor enemyArmorLevel: anInt).
	^newEnemy! !

!Enemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:10'!
initialize
	super initialize.
	health := 5.
	weapon := Weapon new.
	weapon damage: 2.
	weapon accuracy: 2.
	armor := Armor new.
	armor evasion: 2.
	armor reduction: 1.! !

!Enemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:53'!
isEnemy
	^true! !

!Enemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:20'!
nextMovementToX: toX toY: toY onBoard: aBoard
	^self subclassResponsibility ! !

Enemy subclass: #ManhattanEnemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!ManhattanEnemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:46'!
defaultPathName
	^'enemy-crow.png'! !

!ManhattanEnemy methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 03:34'!
directionOfShortestManhattanToX: toX toY: toY FromX: anX Y: aY onBoard: aBoard
	|box northBox westBox |
	
	box := aBoard boxAt: anX at: aY.
	northBox := aBoard boxAt: anX at: aY-1.
	westBox := aBoard boxAt: anX-1 at: aY.
	
	(northBox southWall not & (self x: anX andY: aY closerThanX: anX andY: aY - 1 toX: toX toY: toY)) ifTrue: [ ^1 ].
	(box eastWall not & (self x: anX andY: aY closerThanX: anX +1 andY: aY toX: toX toY: toY)) ifTrue: [ ^2 ].
	(box southWall not & (self x: anX andY: aY closerThanX: anX andY: aY + 1 toX: toX toY: toY)) ifTrue: [ ^3 ].
	(westBox eastWall not & (self x: anX andY: aY closerThanX: anX - 1 andY: aY toX: toX toY: toY)) ifTrue: [ ^4 ].
	^5.! !

!ManhattanEnemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:43'!
nextMovementToX: toX toY: toY onBoard: aBoard
	^self directionOfShortestManhattanToX: toX toY: toY FromX: self x Y: self y onBoard: aBoard.! !

!ManhattanEnemy methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 03:07'!
x: newX andY: newY closerThanX: oldX andY: oldY toX: toX toY: toY
	|currentDistanceX currentDistanceY otherDistanceX otherDistanceY|
	currentDistanceX := (toX - oldX) abs.
	currentDistanceY := (toY - oldY) abs.
	otherDistanceX := (toX - newX) abs.
	otherDistanceY := (toY - newY) abs.
	^otherDistanceX + otherDistanceY > (currentDistanceX + currentDistanceY)! !

Enemy subclass: #PathfindingEnemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!PathfindingEnemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:46'!
defaultPathName
	^'enemy-skeleton.png'! !

!PathfindingEnemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 04:48'!
depthFirstSearchToX: toX toY: toY fromX: anX Y: aY onBoard: aBoard

	| box northBox westBox |
	box := aBoard boxAt: anX at: aY.
	northBox := aBoard boxAt: anX at: aY-1.
	westBox := aBoard boxAt: anX-1 at: aY.

	((self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX y: aY - 1 gotHereFrom: 1 onBoard: aBoard) 
		& northBox southWall not) 
			ifTrue: [^1].
	((self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX + 1 y: aY  gotHereFrom: 2 onBoard: aBoard) 
		& box eastWall not) 
			ifTrue: [^2].
	((self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX y: aY + 1  gotHereFrom: 3 onBoard: aBoard) 
		& box southWall not) 
			ifTrue: [^3].
	((self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX - 1 y: aY  gotHereFrom: 4 onBoard: aBoard) 
		& westBox eastWall not) 
			ifTrue: [^4].
	
	^5

! !

!PathfindingEnemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 04:20'!
nextMovementToX: toX toY: toY onBoard: aBoard
	^self depthFirstSearchToX: toX toY: toY fromX: self x Y: self y onBoard: aBoard.
	! !

!PathfindingEnemy methodsFor: 'mazing' stamp: 'HenrySolberg 7/30/2014 04:45'!
recursiveDepthFirstSearchToX: toX toY: toY fromX: anX y: aY gotHereFrom: aDirection onBoard: aBoard
	|box northBox westBox  targetFound|
	
	targetFound := false.
	
	(anX@aY = (toX@toY)) ifTrue: [ ^true ].
	
	box := aBoard boxAt: anX at: aY.
	northBox := aBoard boxAt: anX at: aY-1.
	westBox := aBoard boxAt: anX-1 at: aY.
	
	(northBox southWall not & (aDirection = 3) not & (targetFound not)) ifTrue: 
		[ targetFound := self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX y: aY - 1 gotHereFrom: 1onBoard: aBoard ].
	(box eastWall not & (aDirection = 4) not & (targetFound not))ifTrue: 
		[ targetFound := self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX + 1 y: aY gotHereFrom: 2 onBoard: aBoard].
	(box southWall not & (aDirection = 1) not & (targetFound not))	ifTrue: 
		[ targetFound := self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX y: aY + 1 gotHereFrom: 3 onBoard: aBoard].
	(westBox eastWall not & (aDirection = 2) not & (targetFound not))	ifTrue: 
		[ targetFound := self recursiveDepthFirstSearchToX: toX toY: toY fromX: anX - 1 y: aY  gotHereFrom: 4 onBoard: aBoard].
	
	^targetFound

! !

Enemy subclass: #RandomEnemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!RandomEnemy class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:46'!
defaultPathName
	^'enemy-rat.png'! !

!RandomEnemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:27'!
nextMovementToX: toX toY: toY onBoard: aBoard
	^self randomDirectionOnBoard: aBoard! !

!RandomEnemy methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/30/2014 03:30'!
randomDirectionOnBoard: aBoard
	^ (aBoard rand) nextInt: 4.! !

Denizen subclass: #Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Player methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/29/2014 16:47'!
hash
	^(self class asString hash * 1000000) + (x hash * 10000 ) + (y hash * 100) + health! !

!Player methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 19:40'!
initialize
	super initialize.
	self weapon: Sword defaultPath .
	self armor: Chain defaultPath.! !

!Player methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/29/2014 16:14'!
number
	^number! !

!Player methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/29/2014 16:14'!
number: aNum
	number := aNum! !

!GameObject class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:10'!
defaultPath
	^self new imagePath: self defaultPathName.! !

!GameObject class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:10'!
defaultPathName
	self subclassResponsibility.! !

!GameObject class methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/16/2014 15:57'!
imagePath: imagePath
	^self new imagePath: imagePath.! !

!GameObject methodsFor: 'using' stamp: 'WestonPanther 7/16/2014 16:28'!
applyTo: aPlayer
	self subclassResponsibility ! !

!GameObject methodsFor: 'hashing' stamp: 'HenrySolberg 7/16/2014 02:59'!
hash
	^(self class asString hash * 10000) + (x hash * 100 ) + (y hash * 1)! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:51'!
health
	^-1! !

!GameObject methodsFor: 'initializing' stamp: 'WestonPanther 7/16/2014 15:58'!
imagePath: aString
	self form:(ImageReadWriter formFromFileNamed: aString).! !

!GameObject methodsFor: 'initializing' stamp: 'HenrySolberg 7/15/2014 04:01'!
initialize
	super initialize.
	self x: 1.
	self y: 1.! !

!GameObject methodsFor: 'using' stamp: 'WestonPanther 7/16/2014 16:18'!
isUsable
	^self subclassResponsibility ! !

!GameObject methodsFor: 'moving' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveDownOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y + 1.! !

!GameObject methodsFor: 'moving' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveLeftOnBoard: aBoard
	self moveOnBoard: aBoard toX: x - 1 toY: y.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/24/2014 12:38'!
moveRandomOnBoard: aBoard
	| direction |
	direction := (aBoard rand) nextInt: 4.
	(direction = 1) ifTrue: [ self moveDownOnBoard: aBoard ].
	(direction = 2) ifTrue: [ self moveRightOnBoard: aBoard ].
	(direction = 3) ifTrue: [ self moveLeftOnBoard: aBoard ].
	(direction = 4) ifTrue: [ self moveUpOnBoard: aBoard ].	! !

!GameObject methodsFor: 'moving' stamp: 'HEnrySolberg 7/10/2014 05:48'!
moveRightOnBoard: aBoard
	self moveOnBoard: aBoard toX: x + 1 toY: y.
	! !

!GameObject methodsFor: 'moving' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveUpOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y - 1.! !

!GameObject methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 00:57'!
x
	^x.! !

!GameObject methodsFor: 'modifying' stamp: 'HEnrySolberg 7/10/2014 04:34'!
x: anX
	x := anX.! !

!GameObject methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 00:57'!
y
	^y.! !

!GameObject methodsFor: 'modifying' stamp: 'HEnrySolberg 7/10/2014 04:34'!
y: aY
	y := aY.! !

GameObject subclass: #Usable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Usable commentStamp: '<historical>' prior: 0!
An Usable is something that can be used with the enter key to some effect.
!

Usable subclass: #Item
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

Item subclass: #Armor
	instanceVariableNames: 'reduction evasion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Armor class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 00:55'!
defaultPathName
	^'plate-armor.png'! !

!Armor class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:28'!
enemyArmorLevel: anInt
	^(self defaultPath)
		evasion: anInt - 1;
		reduction: anInt - 1.! !

!Armor class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:27'!
enemyWeaponLevel: anInt
	^(self defaultPath)
		accuracy: anInt;
		damage: anInt.! !

!Armor methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 19:45'!
applyTo: aPlayer onBoard: aBoard
	| tempArmor |
	tempArmor := aPlayer armor.
	(aPlayer armor class = self class) ifTrue: [ aPlayer armor levelUp. ]
	ifFalse:	[ aPlayer armor: self. 
		aBoard removeUsable: self.
		aBoard at: (aPlayer x) at: (aPlayer y) addGameObject: tempArmor.
	].
	self delete.
	aBoard setupHUDInWindow: (aBoard window).! !

!Armor methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 00:58'!
evasion
	^evasion * level! !

!Armor methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:11'!
evasion: anInt
	evasion := anInt.! !

!Armor methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 00:58'!
reduction
	^reduction * level! !

!Armor methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:11'!
reduction: anInt
	reduction := anInt.! !

Armor subclass: #Chain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Chain class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:28'!
defaultPathName
	^'chain-armor.png'! !

!Chain methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 03:58'!
initialize
	super initialize.
	evasion:=1.
	reduction:=1.! !

Armor subclass: #Leather
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Leather class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:28'!
defaultPathName
	^'leather-armor.png'! !

!Leather methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 03:58'!
initialize
	super initialize.
	evasion:=2.
	reduction:=0.! !

Armor subclass: #Plate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Plate class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:29'!
defaultPathName
	^'plate-armor.png'! !

!Plate methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 03:58'!
initialize
super initialize.
	evasion:=0.
	reduction:=2.! !

!Item class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 00:30'!
randomItem
	|classBag|
	classBag := Bag new.
	classBag add: Chain; add: Leather; add: Plate; add: Axe; add: Club; add: Sword.
	^classBag atRandom.! !

!Item class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 05:24'!
randomItemForLevel: aLevel
	|classBag|
	classBag := Bag new.
	classBag add: Chain; add: Leather; add: Plate; add: Axe; add: Club; add: Sword.
	(aLevel > 5) ifTrue: [ classBag add: Longsword ].
	^classBag atRandom.! !

!Item methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:14'!
initialize
	super initialize.
	level := 1.! !

!Item methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:13'!
level
	^level! !

!Item methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 00:57'!
level: anInt
	level := anInt.! !

!Item methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 03:36'!
levelUp
	level := level + 1.! !

Item subclass: #Weapon
	instanceVariableNames: 'damage accuracy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

Weapon subclass: #Axe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Axe class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:29'!
defaultPathName
	^'axe-weapon.png'! !

!Axe methodsFor: 'as yet unclassified' stamp: 'ChengChang 7/21/2014 22:46'!
initialize
super initialize.
accuracy:=1.
damage:=3.! !

Weapon subclass: #Club
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Club class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:29'!
defaultPathName
	^'club-weapon.png'! !

!Club methodsFor: 'as yet unclassified' stamp: 'ChengChang 7/21/2014 22:47'!
initialize
super initialize.
accuracy:=3.
damage:=1.! !

Weapon subclass: #Longsword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Longsword class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 08:54'!
defaultPathName
	^'longsword-weapon.png'! !

!Longsword methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 05:23'!
initialize
super initialize.
accuracy:=4.
damage:=4.! !

Weapon subclass: #Sword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Sword class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/23/2014 03:29'!
defaultPathName
	^'sword-weapon.png'! !

!Sword methodsFor: 'as yet unclassified' stamp: 'ChengChang 7/21/2014 22:47'!
initialize
super initialize.
accuracy:=2.
damage:=2.! !

!Weapon class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 00:55'!
defaultPathName
	^'sword-weapon.png'! !

!Weapon class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:28'!
enemyWeaponLevel: anInt
	^(self defaultPath)
		accuracy: anInt;
		damage: anInt.! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 10:24'!
accuracy
	^accuracy * level! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:11'!
accuracy: anInt
	 accuracy := anInt.	! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/31/2014 12:45'!
applyTo: aPlayer onBoard: aBoard
	| tempWeapon |
	tempWeapon := aPlayer weapon.
	(aPlayer weapon class = self class) ifTrue:	[ aPlayer weapon levelUp. ]
	ifFalse:	[ aPlayer weapon: self. 
		aBoard removeUsable: self.
		aBoard at: (aPlayer x) at: (aPlayer y) addGameObject: tempWeapon.	
	].
	self delete.
	aBoard setupHUDInWindow: (aBoard window).! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/25/2014 00:59'!
damage
	^damage * level! !

!Weapon methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 04:11'!
damage: anInt
	damage := anInt.! !

Usable subclass: #Stairs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Stairs commentStamp: '<historical>' prior: 0!
A Stairs is what gets you to the next level.
!

!Stairs class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:11'!
defaultPathName
	^'stairs.png'! !

!Stairs methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:33'!
applyTo: aPlayer onBoard: aBoard
	aBoard boardSize: aBoard boardSize windowSize: aBoard windowSize keepWindow: aBoard window level: aBoard level + 1.
	aBoard at: 1 at: 1 addGameObject: aPlayer.! !

!Usable methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/16/2014 16:18'!
isUsable
	^true! !

Morph subclass: #Game
	instanceVariableNames: 'connectionSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Game commentStamp: '<historical>' prior: 0!
A Game is a game application and window.!

!Game methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 04:28'!
debugPrint: aString
	Transcript show: self asString, ':  ' , aString , '(' , Time now asMilliSeconds asString , ')' , Character cr asString! !

!Game methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/24/2014 15:24'!
handleCommand: receivedData withBoard: aBoard andPlayer: aPlayer 
	(receivedData = '28') ifTrue: [aBoard moveGameObjectLeft: aPlayer].
	(receivedData = '31') ifTrue: [aBoard moveGameObjectDown: aPlayer].
	(receivedData = '29') ifTrue: [aBoard moveGameObjectRight: aPlayer].
	(receivedData = '30') ifTrue: [aBoard moveGameObjectUp: aPlayer].
	(receivedData = '114') ifTrue: [aBoard moveGameObjectRandom: aPlayer].
	(receivedData = '13') ifTrue: [
		((aBoard boxAt: (aPlayer x) at: (aPlayer y)) usable class = Stairs) ifTrue: [ 
			self stairsUsedBy: aPlayer withBoard: aBoard.
		] ifFalse: [ 
			aPlayer useOnBoard: aBoard 
		] .
	].
	aBoard nextTurn.
! !

!Game methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/17/2014 15:54'!
stairsUsedBy: aPlayer withBoard: aBoard
	self subclassResponsibility ! !

Game subclass: #GameClient
	instanceVariableNames: 'windowPosition isRunning gb resyncing resyncingMessage yourTurnMessage battle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameClient commentStamp: '<historical>' prior: 0!
A GameClient is the window and connection for modifying and recieving socket data.
!

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 19:02'!
handleKeystroke: anEvent 
	| keyValue | 
	resyncing ifFalse: 
	[  
 		keyValue := anEvent keyValue.
		self handleCommand: (keyValue asString) withBoard:  gb  andPlayer: (gb player).
		isRunning ifTrue: [ connectionSocket sendData: keyValue asString ].
		(battle) ifTrue: [ resyncing := true ].
		(yourTurnMessage isNotNil & battle) ifTrue: [ yourTurnMessage delete. yourTurnMessage := nil].
	]
	ifTrue: 
	[ 
		resyncingMessage isNil ifFalse: [ resyncingMessage delete. ].
		resyncingMessage := GameObject imagePath: 'resyncing.png'. 
		resyncingMessage center: self center. 
		self addMorph: resyncingMessage. 
	]! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/31/2014 12:48'!
handleSocket: interactionSocket withWindow: window
	| receivedData |
		
		[ [interactionSocket isConnected ] whileTrue:  [  
			receivedData := ByteString new.
			[receivedData endsWith: 'Complete>' ] whileFalse: [receivedData := receivedData , interactionSocket receiveData.].
			(receivedData endsWith: '<boardComplete>') ifTrue: [  self syncWithWindow:  window usingData:  receivedData ].
			(receivedData endsWith: '<boardRepresentationComplete>') ifTrue: [  
				(self syncWithWindow:  window usingRepresentationData:  receivedData) ifFalse: [ 
					resyncing := true.
					interactionSocket sendData: '<resync>'.	 
				] ifTrue: [ (battle) ifTrue: [ resyncing := false ] ] ].
			(receivedData endsWith: '<hashComplete>') & (battle not) ifTrue: [ 
				(gb hash asString = (receivedData readStream upToAll: '<hashComplete>')) ifFalse: [ 
					resyncing := true.
					interactionSocket sendData: '<resync>'.
				]
			].
			(receivedData endsWith: '<battleComplete>') ifTrue: [ 
				battle := true.
				
			].
			(window isInWorld) ifFalse: [ ConnectionTimedOut signal ]
			]
		] on: ConnectionTimedOut
		do: [self delete].! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/11/2014 05:12'!
handlesMouseOver: anEvent 
   ^ true! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:17'!
initialize
	super initialize.
	self isRunning: false.
	battle := false.
	windowPosition := 50@50.
	gb := GameBoard new.
	resyncing := false.! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/18/2014 17:36'!
interactUsing: interactionSocket
	| window |
		
	[ 
		window := StandardWindow new.
		window open.
		self color: Color transparent.
		self handleSocket: interactionSocket withWindow: window
	] ensure: [
		interactionSocket closeAndDestroy.
		self delete. 
	] ! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 07:37'!
isRunning
	^ isRunning ! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 07:37'!
isRunning: aBoolean
	isRunning := aBoolean! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 07:29'!
joinIP: anAddress.
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true.
	connectionSocket := Socket newTCP.
	connectionSocket connectTo: anAddress port: 9999.
	[self interactUsing: connectionSocket] fork! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 09:40'!
mouseEnter: anEvent 
    anEvent hand newKeyboardFocus: self! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/11/2014 05:16'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:26'!
stairsUsedBy: aPlayer withBoard: aBoard
	resyncing := true.
	resyncingMessage := (GameObject imagePath: 'resyncing.png').
	resyncingMessage center: self center.
	self addMorph: (resyncingMessage).
	
	! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 08:39'!
stop
	self isRunning: false! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/18/2014 02:51'!
syncWithWindow: aWindow usingData: receivedData

	(receivedData size = 0) ifFalse:
	[
		receivedData readStream upToAll: '<boardComplete>'.
		gb := (FLMaterializer materializeFromByteArray:  receivedData asByteArray).
		(gb class = GameBoard) ifFalse: [self error: 'Non-GameBoard data received!!'].

		windowPosition := aWindow position.
		aWindow addMorph: gb.
"		aWindow position: windowPosition."
		aWindow height: gb height + 30.
		aWindow width: gb width + 10.
		self position: (aWindow layoutBounds topLeft).
		self height: (aWindow layoutBounds bottom - aWindow layoutBounds top).
		self width: (aWindow layoutBounds right - aWindow layoutBounds left).
		aWindow addMorph: self.
		resyncing := false.
		resyncingMessage isNil ifFalse: [ resyncingMessage delete].
	]
! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:58'!
syncWithWindow: aWindow usingRepresentationData: receivedData

	(receivedData size = 0) ifFalse:
	[
		[ receivedData readStream upToAll: '<boardRepresentationComplete>'.
		gb := GameBoard buildFromRepresentation: (FLMaterializer materializeFromByteArray:  receivedData asByteArray) withWindow: aWindow.
		(gb class = GameBoard) ifFalse: [self error: 'Trouble'].

		windowPosition := aWindow position.
		aWindow addMorph: gb.
"		aWindow position: windowPosition."
		aWindow height: gb height + 30.
		aWindow width: gb width + 10.
		self position: (aWindow layoutBounds topLeft).
		self height: (aWindow layoutBounds bottom - aWindow layoutBounds top).
		self width: (aWindow layoutBounds right - aWindow layoutBounds left).
		aWindow addMorph: self.
		resyncing := false.
		yourTurnMessage ifNil: [ 
			yourTurnMessage := GameObject imagePath: 'yourturn.png'. 
			yourTurnMessage bottomRight: self bottomRight. 
			self addMorph: yourTurnMessage.].
		resyncingMessage isNil ifFalse: [ resyncingMessage delete].
		^true
		] on: FLBadSignature do: [ ^false ]
	]
! !

Game subclass: #GameServer
	instanceVariableNames: 'isRunning isRunningLock numConnections finalGameboard turn turnsBeforeBattle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameServer commentStamp: '<historical>' prior: 0!
A GameServer is opens a socket for connections and carries out the game logic. It keeps track of all connections, and their current game state.

Instance Variables
	connectionSocket:		<Object>
	isRunning:		<Object>
	isRunningLock:		<Object>
	numConnections:		<Object>

connectionSocket
	- xxxxx

isRunning
	- xxxxx

isRunningLock
	- xxxxx

numConnections
	- xxxxx
!

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:15'!
handleBattleSocket: interactionSocket withBoard: gb withPlayer: player
	|receivedData window|
	
		window := SystemWindow new.
		finalGameboard ifNil: [ finalGameboard := gb arenaSize: 5 windowSize:  450 keepWindow: gb window ] ifNotNil: [gb window close. gb delete ]. 
		finalGameboard player: player.
		finalGameboard at: (player number) at: (player number) addGameObject: player.
		finalGameboard window openAsIs.
		interactionSocket sendData: '<battleComplete>'.
		(Delay forMilliseconds: 200) wait.
		self sendSerializedBoardRepresentationOf: finalGameboard  onSocket: interactionSocket .
		[interactionSocket isConnected] whileTrue:  
		[
			(self turn = player number) ifTrue: [  
			[
				Transcript show: (player number asString) , ' turn and numConnections is ', numConnections asString, Character cr asString.
				finalGameboard player: player.
				self sendSerializedBoardRepresentationOf: finalGameboard  onSocket: interactionSocket .
				receivedData := ByteString new.
				receivedData := interactionSocket receiveData .
				(receivedData = '<resync>') ifFalse: [  
					self handleCommand: receivedData withBoard: finalGameboard andPlayer: player.
					interactionSocket sendData: (finalGameboard hash) asString, '<hashComplete>'.
				] ifTrue: [ 
					finalGameboard player: player.
		 			self sendSerializedBoardRepresentationOf: finalGameboard onSocket: interactionSocket.
				].
				self turn: (self turn %numConnections) + 1.
			]  on: ConnectionTimedOut
				do: [self delete].
			].
			(Delay forMilliseconds: 100) wait.
		]. ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:29'!
handleSocket: interactionSocket withBoard: gb withPlayer: player
	|counter receivedData finalBattle|
	
		finalBattle := false.
		counter := 0.
		[interactionSocket isConnected ] whileTrue:  
		[
			(finalBattle & (numConnections > 0)) ifFalse: [[
				receivedData := interactionSocket receiveData .
				(receivedData = '<resync>') ifFalse: [  
					self handleCommand: receivedData withBoard: gb andPlayer: player.
					interactionSocket sendData: (gb hash) asString, '<hashComplete>'.
				] ifTrue: [ 
		 			self sendSerializedBoardRepresentationOf: gb onSocket: interactionSocket.
				]
			]  on: ConnectionTimedOut
				do: [ self delete].
			] ifTrue: [  
				self handleBattleSocket: interactionSocket  withBoard: gb withPlayer: player
			].
			(counter < turnsBeforeBattle ) ifTrue: [ counter := counter + 1. ] ifFalse:  [ finalBattle := true ]
		]. ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 8/1/2014 02:22'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	numConnections := 0.
	turn := 1.
	turnsBeforeBattle := 50.
	! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:56'!
interactOnConnection
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/29/2014 16:14'!
interactUsing: interactionSocket
	| player  gb |
		
	[ 
		numConnections := numConnections + 1.
		player := Player defaultPath.
		player number: numConnections.
		(gb := self setupGameBoard: player) openInWindow.		
		self sendSerializedBoardRepresentationOf: gb onSocket: interactionSocket.

		self handleSocket: interactionSocket withBoard: gb withPlayer: player.

	] ensure: [
	interactionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:52'!
isRunning
	^ isRunningLock critical: [ isRunning ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:53'!
isRunning: aBoolean
	isRunningLock critical: [ isRunning := aBoolean ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:16'!
numConnections
	^numConnections ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
numConnections: aNum
	numConnections := aNum! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/18/2014 15:33'!
sendSerializedBoard: aBoard onSocket: aSocket
	|serializedBoard|
	
	serializedBoard := (FLSerializer serializeToByteArray: aBoard).
	serializedBoard := ByteString fromByteArray: serializedBoard.
	aSocket sendData: serializedBoard , '<boardComplete>'.! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:01'!
sendSerializedBoardRepresentationOf: aBoard onSocket: aSocket
	|serializedBoardRepresentation|
	
	serializedBoardRepresentation := (FLSerializer serializeToByteArray: (GameBoardRepresentation fromGameBoard: aBoard)).
	serializedBoardRepresentation := ByteString fromByteArray: serializedBoardRepresentation.
	aSocket sendData: serializedBoardRepresentation , '<boardRepresentationComplete>'.! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:58'!
serve
	[ [ self isRunning ]
	whileTrue: [ self interactOnConnection ] ]
	ensure: [ connectionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 8/1/2014 01:12'!
setupGameBoard: aPlayer
	|gb|
	gb := (GameBoard boardSize: 15 windowSize: 450).
	gb player: aPlayer.
	gb at: 1 at: 1 addGameObject: (aPlayer).
	gb at: gb boardSize at: gb boardSize addGameObject: (Stairs imagePath: 'stairs.png').
	^gb! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:27'!
stairsUsedBy: aPlayer withBoard: aBoard
	aPlayer useOnBoard: aBoard.! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:57'!
start
	isRunningLock critical: [
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: 9999 backlogSize: 10.
	[ self serve ] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:55'!
stop
	self isRunning: false! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 17:48'!
turn
	^isRunningLock critical: [turn]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 17:48'!
turn: aNum
	isRunningLock critical: [turn := aNum]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/30/2014 18:29'!
turnsBeforeBattle: aNum
	turnsBeforeBattle := aNum! !

Morph subclass: #GameBoard
	instanceVariableNames: 'boardSize windowSize board lineWidth player hud level rand enemies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBoard commentStamp: '<historical>' prior: 0!
A GameBoard is a matrix of game boxes and methods for interactions on the game board.

Instance Variables
	board:		matrix of game boxes
	boardSize:		int representing width and height (X by X)
	lineWidth:		width of borders between moxes (int)
	player:		the controllable game object
	windowSize:		square pixel size (int)

!

!GameBoard class methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 03:54'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt
	^self new boardSize: aBoardSizeInt windowSize: aWindowSizeInt.! !

!GameBoard class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 14:06'!
buildFromRepresentation: aRepresentation withWindow: aWindow
	^self new buildFromRepresentation: aRepresentation withWindow: aWindow.! !

!GameBoard methodsFor: 'initializing' stamp: 'WestonPanther 7/28/2014 16:52'!
arenaSize: aBoardSizeInt windowSize: aWindowSizeInt keepWindow: window
	self delete.
	self initialize.
	self setupWindow: window boardSize: aBoardSizeInt windowSize: aWindowSizeInt.

	self buildMaze.
	self seedRand.
	self setupHUDInWindow: window.! !

!GameBoard methodsFor: 'accessing' stamp: 'HenrySolberg 7/18/2014 12:38'!
at: anX at: aY
	"access the denizen at a coord"
	^(board at: anX at: aY) occupant.! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 8/1/2014 00:53'!
at: anX at: aY addGameObject: aGameObject
	(aGameObject isUsable) ifTrue: [ (board at: anX at: aY) setUsable: aGameObject ]
							ifFalse: [ (board at: anX at: aY) setOccupant: aGameObject ].
	aGameObject x: anX; y: aY.
	aGameObject position: (self positionOfX: anX Y: aY).
	self resize: aGameObject.
	self addMorph: aGameObject.! !

!GameBoard methodsFor: 'accessing' stamp: 'HenrySolberg 7/19/2014 10:42'!
board
	^board.! !

!GameBoard methodsFor: 'accessing' stamp: 'WestonPanther 7/16/2014 17:34'!
boardSize
	^boardSize! !

!GameBoard methodsFor: 'initializing' stamp: 'HenrySolberg 7/25/2014 02:50'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt
	self delete.
	self initialize.
	player := GameObject new.
	boardSize := aBoardSizeInt.
	windowSize := aWindowSizeInt.
	lineWidth := 4.
	board := Matrix new: aBoardSizeInt.
	
	"self error."
	self buildMaze.
	self stockMaze.
	self at: boardSize at: boardSize addGameObject: (Stairs imagePath: 'stairs.png').
	self seedRand.! !

!GameBoard methodsFor: 'initializing' stamp: 'HenrySolberg 7/25/2014 02:50'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt keepWindow: window level: aLevel
	self delete.
	self initialize.
	self level: aLevel.
	self setupWindow: window boardSize: aBoardSizeInt windowSize: aWindowSizeInt.

	self buildMaze.
	self stockMaze.
	self at: boardSize at: boardSize addGameObject: (Stairs imagePath: 'stairs.png').
	self seedRand.
	self setupHUDInWindow: window.! !

!GameBoard methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:11'!
boxAt: anX at: aY
	"returns a fully walled box if out of bounds"
	(anX > boardSize | (aY > boardSize) | (anX < 1) | (aY < 1)) ifTrue: [^GameBox new].
	^(board at: anX at: aY).! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 02:21'!
breadthFirstSearchToPlayerFromX: anX Y: aY gotHereFrom: aDirection
	|box northBox westBox returnValue|
	
	returnValue := 0.
	
	(anX@aY = (player x@player y)) ifTrue: [ 	self error. ^aDirection ].
	
	box := self boxAt: anX at: aY.
	northBox := self boxAt: anX at: aY-1.
	westBox := self boxAt: anX-1 at: aY.
	
	(northBox southWall not & (aDirection = 3) not & ((returnValue = 0) | (returnValue = 5))) 
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY - 1 gotHereFrom: 1 ].
	(box eastWall not & (aDirection = 4) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX + 1 Y: aY  gotHereFrom: 2 ].
	(box southWall not & (aDirection = 1) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY + 1  gotHereFrom: 3 ].
	(westBox eastWall not & (aDirection = 2) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX - 1 Y: aY  gotHereFrom: 4 ].
	
	^returnValue

! !

!GameBoard methodsFor: 'mazing' stamp: 'WestonPanther 7/28/2014 15:43'!
buildArena
	|spacing   boxMatrix   |
	
	spacing := windowSize/boardSize.
	boxMatrix := self makeBoxMatrixSize: boardSize withSpacing: spacing.

	boxMatrix do: [ :box | self putBox: box spacing: spacing ]! !

!GameBoard methodsFor: 'initializing' stamp: 'WestonPanther 7/29/2014 16:59'!
buildFromRepresentation: aRepresentation withWindow: aWindow

	self dismissMorph.
	self initialize.
	level := aRepresentation level.
	player := GameObject new.
	rand := aRepresentation rand.
	self setupWindow: aWindow boardSize: aRepresentation boardRepresentation rowCount windowSize: aRepresentation windowSize.
	self color: Color transparent.
	self setupBoardFromRepresentation: aRepresentation.
	player ifNil: [self gameOver.] ifNotNil: [ self setupHUDInWindow: aWindow.].! !

!GameBoard methodsFor: 'mazing' stamp: 'WestonPanther 7/22/2014 02:29'!
buildMaze
	|spacing   boxMatrix  setMatrix  wallList|
	
	spacing := windowSize/boardSize.
	setMatrix := Matrix new: boardSize.
	boxMatrix := self makeBoxMatrixSize: boardSize withSpacing: spacing.
	wallList := OrderedCollection new.
	
	setMatrix indicesDo: [ :i :j |  
		setMatrix at: i at: j put: (DisjointSet new)
	].

	boxMatrix do: [ :box |
		wallList add: { box. true }.
		wallList add: { box. false }
	].

	wallList shuffle.
	boxMatrix := (self mazify: boxMatrix withSet: setMatrix withWalls: wallList).
	boxMatrix do: [ :box | self putBox: box spacing: spacing ]! !

!GameBoard methodsFor: 'mazing' stamp: 'HenrySolberg 7/30/2014 02:49'!
depthFirstSearchToPlayerFromX: anX Y: aY gotHereFrom: aDirection

	| box northBox westBox |
	box := self boxAt: anX at: aY.
	northBox := self boxAt: anX at: aY-1.
	westBox := self boxAt: anX-1 at: aY.

	((self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY - 1 gotHereFrom: 1) & northBox southWall not) ifTrue: [^1].
	((self recursiveDepthFirstSearchToPlayerFromX: anX + 1 Y: aY  gotHereFrom: 2) & box eastWall not) ifTrue: [^2].
	((self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY + 1  gotHereFrom: 3) & box southWall not) ifTrue: [^3].
	((self recursiveDepthFirstSearchToPlayerFromX: anX - 1 Y: aY  gotHereFrom: 4) & westBox eastWall not) ifTrue: [^4].
	
	^5

! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/29/2014 04:20'!
directionOfShortestManhattanToPlayerFromX: anX Y: aY
	|box northBox westBox |
	
	box := self boxAt: anX at: aY.
	northBox := self boxAt: anX at: aY-1.
	westBox := self boxAt: anX-1 at: aY.
	
	(northBox southWall not & (self x: anX andY: aY closerThanX: anX andY: aY - 1)) ifTrue: [ ^1 ].
	(box eastWall not & (self x: anX andY: aY closerThanX: anX +1 andY: aY)) ifTrue: [ ^2 ].
	(box southWall not & (self x: anX andY: aY closerThanX: anX andY: aY + 1)) ifTrue: [ ^3 ].
	(westBox eastWall not & (self x: anX andY: aY closerThanX: anX - 1 andY: aY)) ifTrue: [ ^4 ].
	^5.! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/29/2014 04:05'!
directionOfShortestPathToPlayerFromX: anX Y: aY
	! !

!GameBoard methodsFor: 'modifying' stamp: 'WestonPanther 7/30/2014 17:56'!
fromX: fromX fromY: fromY toX: toX toY: toY
	|mover|
	mover := (board at: fromX at: fromY) occupant.
	mover ifNotNil:
	[ 
		mover x: toX; y: toY.
		mover position: (self positionOfX: toX Y: toY).
		(board at: toX at: toY) setOccupant: mover.
		(board at: fromX at: fromY) setOccupant: nil.
	].! !

!GameBoard methodsFor: 'gaming' stamp: 'HenrySolberg 7/24/2014 05:16'!
gameOver
	self addMorph: (
		(GameObject imagePath: 'gameover.png')
			center: self window center).! !

!GameBoard methodsFor: 'hashing' stamp: 'HenrySolberg 7/15/2014 03:56'!
hash
	^board hash ! !

!GameBoard methodsFor: 'initializing' stamp: 'HenrySolberg 7/24/2014 01:12'!
initialize
	super initialize.
	level := 1.
	hud := Morph new.! !

!GameBoard methodsFor: 'accessing' stamp: 'HenrySolberg 7/22/2014 04:24'!
level
	^level! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/22/2014 04:24'!
level: anInt
	level := anInt! !

!GameBoard methodsFor: 'mazing' stamp: 'WestonPanther 7/16/2014 15:42'!
makeBoxMatrixSize: size withSpacing: spacing
	|boxMatrix newBox|
	
	boxMatrix := Matrix new: size.
	
	boxMatrix indicesDo: [ :i :j | 
		newBox := GameBox northWall: false eastWall: true southWall: true westWall: false tileImage: 'dungeontile.png'.
		newBox x: i.
		newBox y: j.
		(i = 1) ifTrue: [newBox westWall: true].
		(j = 1) ifTrue: [newBox northWall: true].
		newBox width: spacing.
		newBox height: spacing.
		newBox position: ((i-1)*spacing)@((j-1)*spacing).

		boxMatrix at: i at: j put: newBox. 
	].

	^boxMatrix! !

!GameBoard methodsFor: 'mazing' stamp: 'WestonPanther 7/22/2014 02:29'!
mazify: boxMatrix withSet: setMatrix withWalls: wallList
	| tempBox neighbor currentSet |
		
	wallList do:  [ :wall |
		tempBox := wall at: 1.
		currentSet := setMatrix at: (tempBox x) at: (tempBox y) .
		((wall at: 2) = true ) ifTrue: [ 
			(tempBox x < boardSize) ifTrue: [ 
				neighbor := setMatrix at: (tempBox x+1) at: (tempBox y). 
				(DisjointSet find: currentSet) = (DisjointSet find: neighbor ) ifFalse: [ tempBox eastWall: false. DisjointSet unionX: currentSet Y: neighbor ]]
		] ifFalse: [ 
			(tempBox y < boardSize) ifTrue: [ 
				neighbor := setMatrix at: (tempBox x) at: (tempBox y+1). 
				(DisjointSet find: currentSet) = (DisjointSet find: neighbor ) ifFalse: [ tempBox southWall: false. DisjointSet unionX: currentSet Y: neighbor ]]
		].
	].

	^boxMatrix! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 03:41'!
moveEnemyWithAI: anEnemy
	| direction |
	direction := anEnemy nextMovementToX: player x toY: player y onBoard: self.
	(direction = 3) ifTrue: [ self moveGameObjectDown:  anEnemy ].
	(direction = 1) ifTrue: [ self moveGameObjectUp: anEnemy ].
	(direction = 2) ifTrue: [ self moveGameObjectRight: anEnemy ].
	(direction = 4) ifTrue: [ self moveGameObjectLeft: anEnemy ].	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/16/2014 01:13'!
moveGameObjectDown:  aGameObject
	(self wallAt: aGameObject x at: aGameObject y inDirection: 2) ifFalse:
	[ aGameObject moveDownOnBoard: self. ] .! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/16/2014 01:12'!
moveGameObjectLeft:  aGameObject
	(self wallAt: aGameObject x at: aGameObject y inDirection: 3) ifFalse:
	[aGameObject moveLeftOnBoard: self.]! !

!GameBoard methodsFor: 'modifying' stamp: 'WestonPanther 7/24/2014 12:45'!
moveGameObjectRandom: anObject
	| direction |
	direction := (self rand) nextInt: 4.
	(direction = 1) ifTrue: [ self moveGameObjectDown:  anObject ].
	(direction = 2) ifTrue: [ self moveGameObjectUp: anObject ].
	(direction = 3) ifTrue: [ self moveGameObjectRight: anObject ].
	(direction = 4) ifTrue: [ self moveGameObjectLeft: anObject ].	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/16/2014 01:13'!
moveGameObjectRight:  aGameObject
	(self wallAt: aGameObject x at: aGameObject y inDirection: 1) ifFalse:
	[aGameObject moveRightOnBoard: self.]! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 02:21'!
moveGameObjectTowardPlayer: anObject
	| direction |

	direction := self depthFirstSearchToPlayerFromX: anObject x Y: anObject y gotHereFrom: 5.

	(direction = 3) ifTrue: [ self moveGameObjectDown:  anObject ].
	(direction = 1) ifTrue: [ self moveGameObjectUp: anObject ].
	(direction = 2) ifTrue: [ self moveGameObjectRight: anObject ].
	(direction = 4) ifTrue: [ self moveGameObjectLeft: anObject ].	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/29/2014 05:57'!
moveGameObjectTowardPlayerManhattan: anObject
	| direction |

	direction := self directionOfShortestManhattanToPlayerFromX: anObject x Y: anObject y.

	(direction = 3) ifTrue: [ self moveGameObjectDown:  anObject ].
	(direction = 1) ifTrue: [ self moveGameObjectUp: anObject ].
	(direction = 2) ifTrue: [ self moveGameObjectRight: anObject ].
	(direction = 4) ifTrue: [ self moveGameObjectLeft: anObject ].	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/16/2014 01:13'!
moveGameObjectUp:  aGameObject
	(self wallAt: aGameObject x at: aGameObject y inDirection: 0) ifFalse:
	[aGameObject moveUpOnBoard: self.]! !

!GameBoard methodsFor: 'gaming' stamp: 'WestonPanther 7/30/2014 17:38'!
nextTurn
	enemies sort: [ :i :j | i hash < j hash ].
	enemies do: [ :enemy |
		self moveEnemyWithAI: enemy.
	]! !

!GameBoard methodsFor: 'accessing' stamp: 'WestonPanther 7/14/2014 16:44'!
player
	^player! !

!GameBoard methodsFor: 'modifying' stamp: 'WestonPanther 7/14/2014 16:39'!
player: aPlayer
	player := aPlayer.! !

!GameBoard methodsFor: 'accessing' stamp: 'HEnrySolberg 7/10/2014 04:37'!
positionOfX: anX Y: aY
	^(board at: anX at: aY) position.! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/24/2014 00:48'!
putBox: newBox spacing: spacing
	newBox position: (newBox x - 1) * spacing@((newBox y - 1)* spacing).
	newBox position: newBox position + self position.
	newBox resize: spacing@spacing.
	newBox drawBorders: 2.
	board at: (newBox x) at: (newBox y) put: newBox.
	self addMorph: newBox.
	^newBox.
! !

!GameBoard methodsFor: 'accessing' stamp: 'WestonPanther 7/23/2014 14:20'!
rand
	^ rand! !

!GameBoard methodsFor: 'modifying' stamp: 'WestonPanther 7/23/2014 14:17'!
rand: aRandom
	rand := aRandom! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 02:21'!
recursiveBreadthFirstSearchToPlayerFromX: anX Y: aY gotHereFrom: aDirection
	|box northBox westBox returnValue|
	
	returnValue := 0.
	
	(anX@aY = (player x@player y)) ifTrue: [ 	^aDirection ].
	
	box := self boxAt: anX at: aY.
	northBox := self boxAt: anX at: aY-1.
	westBox := self boxAt: anX-1 at: aY.
	
	(northBox southWall not & (aDirection = 3) not & ((returnValue = 0) | (returnValue = 5))) 
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY - 1 gotHereFrom: 1 ].
	(box eastWall not & (aDirection = 4) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX + 1 Y: aY  gotHereFrom: 2 ].
	(box southWall not & (aDirection = 1) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY + 1  gotHereFrom: 3 ].
	(westBox eastWall not & (aDirection = 2) not & ((returnValue = 0) | (returnValue = 5)))
		ifTrue: [ returnValue := self recursiveDepthFirstSearchToPlayerFromX: anX - 1 Y: aY  gotHereFrom: 4 ].
	
	((returnValue = 5) not & (returnValue = 0) not) ifTrue: [^aDirection].
	^returnValue

! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/30/2014 02:31'!
recursiveDepthFirstSearchToPlayerFromX: anX Y: aY gotHereFrom: aDirection
	|box northBox westBox  targetFound|
	
	targetFound := false.
	
	(anX@aY = (player x@player y)) ifTrue: [ 	^true ].
	
	box := self boxAt: anX at: aY.
	northBox := self boxAt: anX at: aY-1.
	westBox := self boxAt: anX-1 at: aY.
	
	(northBox southWall not & (aDirection = 3) not & (targetFound not)) 
		ifTrue: [ targetFound := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY - 1 gotHereFrom: 1 ].
	(box eastWall not & (aDirection = 4) not & (targetFound not))
		ifTrue: [ targetFound := self recursiveDepthFirstSearchToPlayerFromX: anX + 1 Y: aY  gotHereFrom: 2 ].
	(box southWall not & (aDirection = 1) not & (targetFound not))
		ifTrue: [ targetFound := self recursiveDepthFirstSearchToPlayerFromX: anX Y: aY + 1  gotHereFrom: 3 ].
	(westBox eastWall not & (aDirection = 2) not & (targetFound not))
		ifTrue: [ targetFound := self recursiveDepthFirstSearchToPlayerFromX: anX - 1 Y: aY  gotHereFrom: 4 ].
	
	^targetFound

! !

!GameBoard methodsFor: 'modifying' stamp: 'WestonPanther 7/24/2014 15:53'!
remove: anObject
	(board at: (anObject x) at: (anObject y)) setOccupant: nil.
	(anObject class = Enemy) ifTrue: [enemies remove: anObject].
	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/24/2014 05:29'!
removeUsable: anObject
	(board at: (anObject x) at: (anObject y)) setUsable: nil
	! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 8/1/2014 00:53'!
resize: aGameObject
	aGameObject resize: (windowSize / boardSize) @ (windowSize / boardSize).! !

!GameBoard methodsFor: 'initializing' stamp: 'WestonPanther 7/24/2014 14:30'!
seedRand	
	self rand: (Random new seed: (board hash)).! !

!GameBoard methodsFor: 'initializing' stamp: 'HenrySolberg 8/1/2014 02:20'!
setupBoardFromRepresentation: aRepresentation
	| newBox boxRep|

	board := Matrix new: aRepresentation boardRepresentation rowCount.
	enemies := OrderedCollection new.
	
	aRepresentation boardRepresentation indicesDo: [ :i :j |
							boxRep := aRepresentation boardRepresentation  at: i at: j.
							newBox := GameBox northWall: boxRep northWall eastWall: boxRep eastWall southWall: boxRep southWall westWall: boxRep westWall tileImage: 'dungeontile.png'.
							newBox x: i.
							newBox y: j.
							self putBox: newBox spacing: (windowSize/boardSize).
						 ].
					
	aRepresentation boardRepresentation indicesDo: [ :i :j |
						boxRep := aRepresentation boardRepresentation  at: i at: j.
						(boxRep occupantClass = UndefinedObject) ifFalse: [
								self at: i at: j addGameObject: 
									((boxRep occupantClass onLevel: level) health: boxRep occupantHealth). ].
								((self at: i at: j) class = Player) ifTrue: 
								[ 
									(self at: i at: j) weapon: boxRep occupantWeaponClass defaultPath.
									(self at: i at: j) weapon level: boxRep occupantWeaponLevel.
									(self at: i at: j) armor: boxRep occupantArmorClass defaultPath.
									(self at: i at: j) armor level: boxRep occupantArmorLevel.
									(self at: i at: j) imagePath: ('enemy-player.png').
									self resize: (self at: i at: j).
								 ]. (self at: i at: j) isNil ifFalse: [(self at: i at: j) isEnemy ifTrue: [
									enemies add: (self at: i at: j).
								].].
							(boxRep usableClass = UndefinedObject) ifFalse: [self at: i at: j addGameObject: boxRep usableClass defaultPath. ].
						 ].
	
	player := self at: aRepresentation playerX at: aRepresentation playerY.
	player ifNotNil: [player imagePath: 'player.png'. self resize: player.].! !

!GameBoard methodsFor: 'initializing' stamp: 'HenrySolberg 7/25/2014 05:15'!
setupHUDInWindow: aWindow
	|healthMorph levelMorph weaponMorph armorMorph subMorph hudMorph |
	
	hudMorph := Morph new.
	
	healthMorph := (TextMorph new newContents: 'health: ' , player health asString).
	healthMorph wrapFlag: false.
	healthMorph position: self bottomLeft + (5@20 negated ).
	
	levelMorph := (TextMorph new newContents: 'level ' , self level asString).
	levelMorph wrapFlag: false.
	levelMorph position: self bottomLeft + (95@20 negated ).
	
	armorMorph := (TextMorph new newContents: "player armor class asString" '       ' , player armor level asString).
	armorMorph wrapFlag: false.
	subMorph := player armor class defaultPath.
	subMorph resize: 30@30.
	subMorph position: 0@12 negated.
	armorMorph addMorph: subMorph.
	armorMorph position: self bottomLeft + (185@20 negated ).
	
	weaponMorph := (TextMorph new newContents: "player weapon class asString" '      ' , player weapon level asString).
	weaponMorph wrapFlag: false.
	subMorph := player weapon class defaultPath.
	subMorph resize: 30@30.
	subMorph position: 0@12 negated.
	weaponMorph addMorph: subMorph.
	weaponMorph position: self bottomLeft + (275@20 negated ).
	
	hudMorph addMorph: levelMorph.
	hudMorph addMorph: healthMorph.
	hudMorph addMorph: armorMorph.
	hudMorph addMorph: weaponMorph.

	hud dismissMorph.
	hud := hudMorph.
	self addMorph: hud.
! !

!GameBoard methodsFor: 'initializing' stamp: 'WestonPanther 7/30/2014 18:08'!
setupWindow: window boardSize: aBoardSizeInt windowSize: aWindowSizeInt
	window submorphsDo: [ 
		:submorph | 
		(submorph class = GameClient | submorph class = GameBoard) ifTrue: [submorph delete]. 
	].
	boardSize := aBoardSizeInt.
	windowSize := aWindowSizeInt.
	lineWidth := 4.
	board := Matrix new: aBoardSizeInt.
	self height: windowSize + 35.
	self width: windowSize.
	self position: window position + (5@28).
	window addMorph: self.! !

!GameBoard methodsFor: 'mazing' stamp: 'WestonPanther 7/30/2014 18:05'!
stockMaze
	|randomX randomY enemy|
	
	enemies := OrderedCollection new.
	1 to: level do: 
	[ 
		:i |
		randomX := (Random new next * boardSize) ceiling.
		randomY := (Random new next * boardSize) ceiling.
		self at: randomX at: randomY addGameObject: (Item randomItemForLevel: level) defaultPath.
		randomX := (Random new next * boardSize) ceiling.
		randomY := (Random new next * boardSize) ceiling.
		((self at: randomX at: randomY) isNotNil | (randomX = 1 & randomY = 1)) ifFalse:
		[ 
			enemy := (Enemy onLevel: level).
			enemies add: enemy.
			self at: randomX at: randomY addGameObject: enemy.
		 ].
	].! !

!GameBoard methodsFor: 'accessing' stamp: 'HenrySolberg 7/16/2014 01:23'!
wallAt: x at: y inDirection: aDirection
	|thisBox northBox eastBox southBox westBox|
	thisBox := (self boxAt: x at: y).
	northBox := (self boxAt: x at: y-1).
	eastBox := (self boxAt: x+1 at: y).
	southBox := (self boxAt: x at: y+1).
	westBox := (self boxAt: x-1 at: y).
	(aDirection = 0) ifTrue: [ ^ thisBox northWall | northBox southWall ].
	(aDirection = 1) ifTrue: [ ^ thisBox eastWall | eastBox westWall ].
	(aDirection = 2) ifTrue: [ ^ thisBox southWall | southBox northWall ].
	(aDirection = 3) ifTrue: [ ^ thisBox westWall |westBox eastWall ].
	^self error: 'invalid direction'.! !

!GameBoard methodsFor: 'accessing' stamp: 'WestonPanther 7/16/2014 17:34'!
windowSize
	^windowSize! !

!GameBoard methodsFor: 'modifying' stamp: 'HenrySolberg 7/29/2014 03:48'!
x: newX andY: newY closerThanX: oldX andY: oldY
	|currentDistanceX currentDistanceY otherDistanceX otherDistanceY|
	currentDistanceX := (player x - oldX) abs.
	currentDistanceY := (player y - oldY) abs.
	otherDistanceX := (player x - newX) abs.
	otherDistanceY := (player y - newY) abs.
	^otherDistanceX + otherDistanceY > (currentDistanceX + currentDistanceY)! !

Object subclass: #DisjointSet
	instanceVariableNames: 'parent rank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!DisjointSet commentStamp: '<historical>' prior: 0!
A DisjointSet is data structure to keep track of our boxes during maze generation.

Instance Variables
	parent:		A parent represents the parent of this set.
	rank:		Rank represents the number of nodes in this set.

parent
	- xxxxx

rank
	- xxxxx
!

!DisjointSet class methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/22/2014 00:02'!
find: x
	(x parent = x) ifFalse: [ x parent: (DisjointSet find: (x parent))  ].
	^(x parent)! !

!DisjointSet class methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/22/2014 00:06'!
unionX: x Y: y
	| xRoot yRoot |
	xRoot := DisjointSet find: x.
	yRoot := DisjointSet find: y.
	
	(xRoot rank < yRoot rank) ifTrue: [ xRoot parent: yRoot  ]
	ifFalse: [ yRoot parent: xRoot ].
	(yRoot rank = xRoot rank) ifTrue: [ yRoot parent: xRoot. xRoot rank: (xRoot rank + 1) ] ! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:44'!
initialize
	parent := self.
	rank := 0! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:53'!
parent
	^parent! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:54'!
parent: aNode
	parent := aNode! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:54'!
rank
	^rank! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:54'!
rank: aRank
	rank := aRank! !

!DisjointSet methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/21/2014 22:50'!
unionX: x y: y
	| xRoot yRoot |
	
	(xRoot = yRoot) ifTrue: [ ].! !

Object subclass: #GameBoardRepresentation
	instanceVariableNames: 'boardRepresentation windowSize playerX playerY level rand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBoardRepresentation class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 10:29'!
fromGameBoard: aBoard
	^self new fromGameBoard: aBoard.! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:14'!
boardRepresentation
	^ boardRepresentation! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/24/2014 14:32'!
fromGameBoard: aBoard
	boardRepresentation := Matrix new: aBoard boardSize.
	windowSize := aBoard windowSize.
	playerX := aBoard player x.
	playerY := aBoard player y.
	rand := aBoard rand.
	aBoard board indicesDo: [ :i :j | boardRepresentation at: i at: j put: (GameBoxRepresentation fromGameBox: (aBoard boxAt: i at: j))].
	level := aBoard level.! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/22/2014 04:36'!
level
	^level! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 14:01'!
playerX
	^playerX! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 14:01'!
playerY
	^playerY! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/24/2014 14:32'!
rand
	^rand! !

!GameBoardRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:16'!
windowSize
	^windowSize! !

Object subclass: #GameBoxRepresentation
	instanceVariableNames: 'northWall westWall southWall eastWall occupantClass occupantHealth usableClass occupantArmorClass occupantArmorLevel occupantWeaponClass occupantWeaponLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBoxRepresentation class methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 10:37'!
fromGameBox: aBox
	^self new fromGameBox: aBox.! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:16'!
eastWall
	^ eastWall! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/26/2014 00:50'!
fromGameBox: aBox
	northWall := aBox northWall.
	southWall := aBox southWall.
	westWall := aBox westWall.
	eastWall := aBox eastWall.
	aBox occupant ifNotNil: [occupantHealth := aBox occupant health.].
	occupantClass := aBox occupant class.
	usableClass := aBox usable class.
	occupantClass = Player ifTrue:
	[ 
		occupantArmorClass := aBox occupant armor class.
		occupantWeaponClass := aBox occupant weapon class.
		occupantWeaponLevel  := aBox occupant weapon level.
		occupantArmorLevel := aBox occupant armor level.
	].! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:16'!
northWall
	^ northWall! !

!GameBoxRepresentation methodsFor: 'accessing' stamp: 'HenrySolberg 7/25/2014 01:17'!
occupantArmorClass
	^ occupantArmorClass! !

!GameBoxRepresentation methodsFor: 'accessing' stamp: 'HenrySolberg 7/25/2014 01:17'!
occupantArmorLevel
	^ occupantArmorLevel! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:17'!
occupantClass
	^ occupantClass! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/24/2014 03:29'!
occupantHealth
	^ occupantHealth! !

!GameBoxRepresentation methodsFor: 'accessing' stamp: 'HenrySolberg 7/25/2014 01:16'!
occupantWeaponClass
	^ occupantWeaponClass! !

!GameBoxRepresentation methodsFor: 'accessing' stamp: 'HenrySolberg 7/25/2014 01:16'!
occupantWeaponLevel
	^ occupantWeaponLevel! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:16'!
southWall
	^ southWall! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:21'!
usableClass
	^ usableClass! !

!GameBoxRepresentation methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/19/2014 11:17'!
westWall
	^ westWall! !
Enemy initialize!
